#include <cstdio>
#include <cstdlib>
#include <assert.h>


#include "circuit.h"

int main(int args, char* argv[]) {

    if(args != 2) {
        printf("usage: ./atpg <XXX.bench>\n");
        exit(1);
    }

    Circuit circuit;

    printf("parsing file %s...\n", argv[1]);
    circuit.parse_from_file(argv[1]);
    printf("====== Circuit Statistics ====== \n");
    printf("PI:\t%ld\n", circuit.PIs.size());
    printf("PO:\t%ld\n", circuit.POs.size());
    printf("Gates:\t%ld\n", circuit.name2gate.size());

    printf("cal topo index ...\n");
    circuit.cal_topo_index();
    for(Gate* gate : circuit.gates) {
        assert(gate->topo > 0);
    }

    return 0;
}